# arrayfire.arith module

Math functions (sin, sqrt, exp, etc).

`arrayfire.arith.``abs`(a)

  Find the absolute values.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > Contains the absolute values of the inputs.

`arrayfire.arith.``acos`(a)

  Arc Cosine of each element in the array.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the arc cosine of each value from a.

`arrayfire.arith.``acosh`(a)

  Arc Hyperbolic Cosine of each element in the array.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the arc hyperbolic cosine of each value from a.

`arrayfire.arith.``arg`(a)

  Find the theta value of the inputs in polar co-ordinates.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > Contains the theta values.

`arrayfire.arith.``asin`(a)

  Arc Sine of each element in the array.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the arc sine of each value from a.

`arrayfire.arith.``asinh`(a)

  Arc Hyperbolic Sine of each element in the array.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the arc hyperbolic sine of each value from a.

`arrayfire.arith.``atan`(a)

  Arc Tangent of each element in the array.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the arc tangent of each value from a.

`arrayfire.arith.``atan2`(lhs, rhs)

  Find the arc tan using two values.

  Parameters:

  lhs : af.Array or scalar

  > Multi dimensional arrayfire array or a scalar number.

  rhs : af.Array or scalar

  > Multi dimensional arrayfire array or a scalar number.

  Returns:

  out : af.Array

  > Contains the value arc tan values where: - lhs contains the sine values. - rhs contains the cosine values.

`arrayfire.arith.``atanh`(a)

  Arc Hyperbolic Tangent of each element in the array.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the arc hyperbolic tangent of each value from a.

`arrayfire.arith.``cast`(a, dtype)

  Cast an array to a specified type

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  dtype: af.Dtype

  > Must be one of the following:
  >   - Dtype.f32 for float
  >   - Dtype.f64 for double
  >   - Dtype.b8 for bool
  >   - Dtype.u8 for unsigned char
  >   - Dtype.s32 for signed 32 bit integer
  >   - Dtype.u32 for unsigned 32 bit integer
  >   - Dtype.s64 for signed 64 bit integer
  >   - Dtype.u64 for unsigned 64 bit integer
  >   - Dtype.c32 for 32 bit complex number
  >   - Dtype.c64 for 64 bit complex number

  Returns

  ——–

  out : af.Array

  > array containing the values from a after converting to dtype.

`arrayfire.arith.``cbrt`(a)

  Cube root of each element in the array.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the cube root of each value from a.

`arrayfire.arith.``ceil`(a)

  Round the values towards a bigger integer.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the ceiled values.

`arrayfire.arith.``conjg`(a)

  Find the complex conjugate values of the input.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing copmplex conjugate values from a.

`arrayfire.arith.``cos`(a)

  Cosine of each element in the array.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the cosine of each value from a.

`arrayfire.arith.``cosh`(a)

  Hyperbolic Cosine of each element in the array.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the hyperbolic cosine of each value from a.

`arrayfire.arith.``cplx`(lhs, rhs=None)

  Create a complex array from real inputs.

  Parameters:

  lhs : af.Array or scalar

  > Multi dimensional arrayfire array or a scalar number.

  rhs : optional: af.Array or scalar. default: None.

  > Multi dimensional arrayfire array or a scalar number.

  Returns:

  out : af.Array

  > Contains complex values whose - real values contain values from lhs - imaginary values contain values from rhs (0 if rhs is None)

`arrayfire.arith.``erf`(a)

  Error function of each element in the array.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the error function of each value from a.

`arrayfire.arith.``erfc`(a)

  Complementary error function of each element in the array.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the complementary error function of each value from a.

`arrayfire.arith.``exp`(a)

  Exponential of each element in the array.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the exponential of each value from a.

`arrayfire.arith.``expm1`(a)

  Exponential of each element in the array minus 1.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the exponential of each value from a.

`arrayfire.arith.``factorial`(a)

  factorial of each element in the array.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the factorial of each value from a.

`arrayfire.arith.``floor`(a)

  Round the values towards a smaller integer.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the floored values.

`arrayfire.arith.``hypot`(lhs, rhs)

  Find the value of the hypotunese.

  Parameters:

  lhs : af.Array or scalar

  > Multi dimensional arrayfire array or a scalar number.

  rhs : af.Array or scalar

  > Multi dimensional arrayfire array or a scalar number.

  Returns:

  out : af.Array

  > Contains the value of sqrt(lhs**2, rhs**2).

`arrayfire.arith.``imag`(a)

  Find the imaginary values of the input.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the imaginary values from a.

`arrayfire.arith.``isinf`(a)

  Check if each element of the input is infinity.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the output after checking if each value of a is inifnite.

`arrayfire.arith.``isnan`(a)

  Check if each element of the input is NaN.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the output after checking if each value of a is NaN.

`arrayfire.arith.``iszero`(a)

  Check if each element of the input is zero.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the output after checking if each value of a is 0.

`arrayfire.arith.``lgamma`(a)

  Performs the logarithm of gamma function for each element in the array.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the output of logarithm of gamma function of each value from a.

`arrayfire.arith.``log`(a)

  Natural logarithm of each element in the array.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the natural logarithm of each value from a.

`arrayfire.arith.``log10`(a)

  Logarithm base 10 of each element in the array.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the logarithm base 10 of each value from a.

`arrayfire.arith.``log1p`(a)

  Logarithm of each element in the array plus 1.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the the values of log(a) + 1

`arrayfire.arith.``log2`(a)

  Logarithm base 2 of each element in the array.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the logarithm base 2 of each value from a.

`arrayfire.arith.``maxof`(lhs, rhs)

  Find the maximum value of two inputs at each location.

  Parameters:

  lhs : af.Array or scalar

  > Multi dimensional arrayfire array or a scalar number.

  rhs : af.Array or scalar

  > Multi dimensional arrayfire array or a scalar number.

  Returns:

  out : af.Array

  > array containing the maximum value at each location of the inputs.

`arrayfire.arith.``minof`(lhs, rhs)

  Find the minimum value of two inputs at each location.

  Parameters:

  lhs : af.Array or scalar

  > Multi dimensional arrayfire array or a scalar number.

  rhs : af.Array or scalar

  > Multi dimensional arrayfire array or a scalar number.

  Returns:

  out : af.Array

  > array containing the minimum value at each location of the inputs.

`arrayfire.arith.``pow`(lhs, rhs)

  Find the power of two inputs at each location.

  Parameters:

  lhs : af.Array or scalar

  > Multi dimensional arrayfire array or a scalar number.

  rhs : af.Array or scalar

  > Multi dimensional arrayfire array or a scalar number.

  Returns:

  out : af.Array

  > array containing the value of lhs ** (rhs)

`arrayfire.arith.``pow2`(a)

  Raise 2 to the power of each element in input.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array where each element is 2 raised to power of the corresponding value from a.

`arrayfire.arith.``real`(a)

  Find the real values of the input.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the real values from a.

`arrayfire.arith.``rem`(lhs, rhs)

  Find the remainder.

  Parameters:

  lhs : af.Array or scalar

  > Multi dimensional arrayfire array or a scalar number.

  rhs : af.Array or scalar

  > Multi dimensional arrayfire array or a scalar number.

  Returns:

  out : af.Array

  > Contains the remainders after dividing each value of lhs` with those in rhs.

`arrayfire.arith.``root`(lhs, rhs)

  Find the root values of two inputs at each location.

  Parameters:

  lhs : af.Array or scalar

  > Multi dimensional arrayfire array or a scalar number.

  rhs : af.Array or scalar

  > Multi dimensional arrayfire array or a scalar number.

  Returns:

  out : af.Array

  > array containing the value of lhs ** (1/rhs)

`arrayfire.arith.``round`(a)

  Round the values to nearest integer.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the values rounded to nearest integer.

`arrayfire.arith.``sigmoid`(a)

  Raise 2 to the power of each element in input.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array where each element is outout of a sigmoid function for the corresponding value from a.

`arrayfire.arith.``sign`(a)

  Find the sign of the inputs.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing -1 for negative values, 1 otherwise.

`arrayfire.arith.``sin`(a)

  Sine of each element in the array.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the sine of each value from a.

`arrayfire.arith.``sinh`(a)

  Hyperbolic Sine of each element in the array.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the hyperbolic sine of each value from a.

`arrayfire.arith.``sqrt`(a)

  Square root of each element in the array.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the square root of each value from a.

`arrayfire.arith.``tan`(a)

  Tangent of each element in the array.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the tangent of each value from a.

`arrayfire.arith.``tanh`(a)

  Hyperbolic Tangent of each element in the array.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the hyperbolic tangent of each value from a.

`arrayfire.arith.``tgamma`(a)

  Performs the gamma function for each element in the array.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the output of gamma function of each value from a.

`arrayfire.arith.``trunc`(a)

  Round the values towards zero.

  Parameters:

  a : af.Array

  > Multi dimensional arrayfire array.

  Returns:

  out : af.Array

  > array containing the truncated values.